"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("./util");

var _default = {
  meta: {
    docs: {
      url: (0, _util.getDocsUrl)(__filename)
    },
    messages: {
      preferCalledWith: 'Prefer {{name}}With(/* expected args */)'
    },
    schema: []
  },

  create(context) {
    return {
      CallExpression(node) {
        // Could check resolves/rejects here but not a likely idiom.
        if ((0, _util.expectCaseWithParent)(node) && !(0, _util.expectNotCase)(node)) {
          const methodNode = (0, _util.method)(node);
          const name = methodNode.name;

          if (name === 'toBeCalled' || name === 'toHaveBeenCalled') {
            context.report({
              data: {
                name
              },
              messageId: 'preferCalledWith',
              node: methodNode
            });
          }
        }
      }

    };
  }

};
exports.default = _default;