"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("./util");

var _default = {
  meta: {
    docs: {
      url: (0, _util.getDocsUrl)(__filename)
    },
    messages: {
      useToBeUndefined: 'Use toBeUndefined() instead'
    },
    fixable: 'code',
    schema: []
  },

  create(context) {
    return {
      CallExpression(node) {
        const is = (0, _util.expectToBeCase)(node, undefined) || (0, _util.expectToEqualCase)(node, undefined);
        const isNot = (0, _util.expectNotToEqualCase)(node, undefined) || (0, _util.expectNotToBeCase)(node, undefined);

        if (is || isNot) {
          context.report({
            fix(fixer) {
              if (is) {
                return [fixer.replaceText((0, _util.method)(node), 'toBeUndefined'), fixer.remove((0, _util.argument)(node))];
              }

              return [fixer.replaceText((0, _util.method2)(node), 'toBeUndefined'), fixer.remove((0, _util.argument2)(node))];
            },

            messageId: 'useToBeUndefined',
            node: is ? (0, _util.method)(node) : (0, _util.method2)(node)
          });
        }
      }

    };
  }

};
exports.default = _default;